<?php
/*
 * Created on 31.10.2005
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */
#################################### Parse News.php #############################################
# This file takes the posted variables from add_news.php and checks if all fields are present
# If everything is ok, the values are entered in the database news table. If not, the field
# is highlighted and the user has to reenter the values.

include_once("../main/header.php"); # include the header
include_once("../database/global_variables.inc"); # include the database connection script

$error = array(); # create an array to hold the fields which throw an error

# Check the incoming POST variables - if missing or empty, throw an error and add the field to the error array
if(isset($_POST['news_date']) && !empty($_POST['news_date']))
{ $news_date = $_POST['news_date']; }
else { 	
	$error['news_date'] = $_POST['news_date'];
	 }
	 
if(isset($_POST['news_title']) && !empty($_POST['news_title']))
{ $news_title = $_POST['news_title']; }
else { 	
	$error['news_title'] = $_POST['news_title'];
	 }
	 
if(isset($_POST['news_content']) && !empty($_POST['news_content']))
{ $news_content = $_POST['news_content']; }
else { 	
	$error['news_content'] = $_POST['news_content'];
	 }

if(isset($_POST['news_search_terms']) && !empty($_POST['news_search_terms']))
{ $news_search_terms = $_POST['news_search_terms']; }
else { 	
	$error['news_search_terms'] = $_POST['news_search_terms'];
	 }
	 
if(isset($_POST['news_identification']) && !empty($_POST['news_identification']))
{ $news_identification = $_POST['news_identification']; }
else { 	
	$error['news_identification'] = $_POST['news_identification'];
	 }
	 
if(isset($_POST['real_name']) && !empty($_POST['real_name']))
{ $news_author= $_POST['real_name']; }
else { 	
	$error['news_author'] = $_POST['real_name'];
	 }
	 
if(isset($_POST['user_email']) && !empty($_POST['user_email']))
{ $news_author_email= $_POST['user_email']; }
else { 	
	$error['user_email'] = $_POST['user_email'];
	 }

$required = array(
"news_title" => "news_title",
"news_author" => "news_author",
"news_content" => "news_content",
"news_identification" => "news_identification"
);


# cross check the required array with the error array. Create a new array with existing critical errors
$critical_missing = array();
foreach($required as $key => $variable)
{
if(array_key_exists("$key", $error))
{
$critical_missing["E".$key] = $_POST[$key];
}
}

$count_critical = count($critical_missing);
if($count_critical != "0")
{
	extract($error); # extract the variables from the error array for reinsertion
	extract($critical_missing); # extract the critical missing variables (prefixed wirh E)
	
# In the next section, the form will be displayed again (given that there were errors)
# The fields which did not throw a critical error will be filled out with the values that the
# user originally added (these values are still contained in $_POST). The fields which threw a
# critical error will be highlighted in red. A simple if clause is used before each field name.
# If the field name represents a value in the array critical_missing, prefixed with E (to distinguish from error())
# then the fieldname will be highlighted in red. A bit agriculturally, this conditional clause is
# carried out on every field name. This makes it unnecessary to establish (apart from the $required array)
# which fields are required. Thus, only if the variable !isset will the field be highlighted. The
# variable will only then be !isset if it is contained in $critical_missing (prefixed by E)

?>
<div class="content"><br/>
<strong>You neglected to fill in a Required Field:</strong><br/>
The news item cannot be entered in the database as at least one Required Fields was not filled out 
or was not filled out properly. Please fill out the form again (the correct values which you entered
in the previous step have been pre-entered for your convenience) and pay special attention to the 
fields highlighted in red - these are the Required Fields which were not filled out properly.
<br/>
<br/>
<table width="70%" cellpadding="2" cellspacing="2" class="content">
<tr bgcolor="EEF6EF">
<form action="<?=$PHP_SELF?>" method="POST">
<input type="hidden" name="username" value="<?=$username?>"/>
<input type="hidden" name="real_name" value="<?=$real_name?>"/>
<input type="hidden" name="user_email" value="<?=$user_email?>"/>
<td>The date and time of this entry is:</td><td><? echo date("Y-m-d H:i:s",time()); ?></td>
</tr>
<tr bgcolor="EEF6EF">
<td><? if(isset($Enews_title)) {echo "<font color=\"red\">";} ?>Please enter a title for the news item<? if(isset($Enews_title)) {echo "</font>";} ?>: <font color="#FF0000">*</font></td><td><input type="text" name="news_title" size="25" value="<?=$news_title?>"/></td>
</tr>
<tr bgcolor="EEF6EF">
<td valign="top"><? if(isset($Enews_content)) {echo "<font color=\"red\">";} ?>Please enter the news content<? if(isset($Enews_content)) {echo "</font>";} ?>: <font color="#FF0000">*</font></td><td valign="top"><textarea name="news_content" cols="30" rows="6"><?=$news_content?></textarea></td>
</tr>
<tr bgcolor="EEF6EF">
<td>Please enter some search terms, to help others find your news item:</td><td><input type="text" name="news_search_terms" size="25" value="<?=$news_search_terms?>"/></td>
</tr>
<tr bgcolor="EEF6EF">
<td valign="top">
<? if(isset($Enews_identification)) {echo "<font color=\"red\">";} ?>How do you want to be identified as author of this news item<? if(isset($Enews_identification)) {echo "</font>";} ?>: <font color="#FF0000">*</font></td>
<td>Full Name & E-Mail &nbsp; <input type="radio" name="news_identification" value="fullname_email" <? if($news_identification == "fullname_email") { echo "checked=\"checked\""; } ?>
/><br/>
    Full Name only &nbsp; <input type="radio" name="news_identification" value="full_name" <? if($news_identification == "full_name") { echo "checked=\"checked\""; } ?>/><br/>
    Username & E-Mail &nbsp; <input type="radio" name="news_identification" value="user_email" <? if($news_identification == "user_email") { echo "checked=\"checked\""; } ?>/><br/>
    Username only &nbsp; <input type="radio" name="news_identification" value="username" <? if($news_identification == "username") { echo "checked=\"checked\""; } ?>/><br/>
    Anonymous &nbsp; <input type="radio" name="news_identification" value="anonymous" <? if($news_identification == "anonymous") { echo "checked=\"checked\""; } ?>/><br/>
</td>
</tr>
</table>
<br/>
<input type="submit" name="submit" value="Insert News"/>
</form>
</div>
<?
}
# if everything is ok, get the highest index entry from the news table and increment it by 1
else {
@mysql_select_db($db_database) or die( "Unable to select database"); # Connect to the appropriate database or error
$find_max_id = "SELECT news_number FROM news ORDER BY news_number DESC LIMIT 1"; # find maximum
$exec_find_max_id = mysql_query($find_max_id) or die (mysql_error());
while ($id_recordset = mysql_fetch_object($exec_find_max_id))
{
$max_id = $id_recordset -> news_number;

$news_number = $max_id+1;

}
	
$insert = "INSERT INTO news VALUES('', '{$news_number}', '{$news_date}', '{$news_author}', '{$news_author_email}', '{$news_title}', '{$news_search_terms}', '{$news_content}', '{$news_identification}', '', '', '', '', '', '', '', '')";
$exec_insert = mysql_query($insert) or die (mysql_error());
if($exec_insert) { echo "<div class=\"content\"><br/>" .
		"<strong>Your news item was successfully added to the database:</strong><br/>" .
		"The news item has been added to the database and can now be viewed by all CMapp users. Whereas the original" .
		"news item cannot be modified, you can add comments, either using your real name, username and/or email. You can delete " .
		"your news items at any time<br/><br/>"; 
		
   echo "<strong>What do you want to do now?</strong><br/><br/><form action=\"action_now.php\" method=\"GET\"><select name=\"action\"><option value=\"add_another\">Add A Contract</option>" .
		"<option value=\"select_all\">Select All Contracts</option>" .
		"<option value=\"add_similar\">Add Similar Contract</option>" .
		"<option value=\"modify_now\">Modify Again</option>" .
		"<option value=\"remove_now\">Remove This Contract</option>" .
		"</select>&nbsp;<input type=\"submit\" name=\"submit\" value=\"Proceed\"></form>";
		}
}
?>